<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\lists\goods;


use app\adminapi\lists\BaseAdminDataLists;
use app\common\model\goods\Goods;
use app\common\lists\ListsSearchInterface;
use app\common\model\goods_category\GoodsCategory;
use app\common\service\FileService;
use think\db\Query;
use think\facade\Log;


/**
 * Goods列表
 * Class GoodsLists
 * @package app\adminapi\listsgoods
 */
class GoodsLists extends BaseAdminDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2024/07/07 18:37
     */
    public function setSearch(): array
    {
        return [
            '=' => ['goods_status','is_agent','is_activity'],
            '%like%' => ['goods_name','goods_brand'],
            'between' => ['service_total', 'service_fee'],
        ];
    }

    public function queryWhere()
    {
        $where = [];
        $where['is_show'] = 1;//后台正常显示商品
        if (!empty($this->params['goods_category_id'])) {
            $goodsCategoryId = end($this->params['goods_category_id']);
            $goodsCategoryData = GoodsCategory::where(['status'=>1])->order(['pid' => 'asc','weigh' => 'desc', 'id' => 'desc'])
                ->select()->toArray();
            $ids =get_tree_ids($goodsCategoryData,$goodsCategoryId);
            $ids[] = $goodsCategoryId;
            $where[] = ['goods_category_id','in' ,$ids];
        }
        if(empty($this->params['user_id'])){
            $where[] = ['user_id','=' ,0];
        } else {
            $where[] = ['user_id','=' ,$this->params['user_id']];
        }
        if (isset($this->params['labels']) && !empty($this->params['labels'])) {
            $sqls = [];
            foreach ($this->params['labels'] as $item) {
                $sqls[] = "FIND_IN_SET({$item}, labels) > 0";
            }
            $query_sql = implode(' OR ', $sqls);
            $period_ids = Goods::where('labels','<>', '')->whereRaw($query_sql)->column('id');
            $where[] = [ 'id','IN',$period_ids?:[0]];
        }
        if (isset($this->params['property_activity_id']) && !empty($this->params['property_activity_id'])) {
            // 筛选已选过的
            $where[] = ['is_activity','=' ,1];//100000
        }
        return $where;
    }

    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2024/07/07 18:37
     */
    public function lists(): array
    {
        $lists = Goods::with(['goodsCategory'=>function (Query $query) {
            $query->field('name');
        },'performanceRules'=>function (Query $query) {
            $query->field('type,rate');
        }])
            ->where($this->searchWhere)
            ->where($this->queryWhere())
            ->order(['id' => 'desc'])
            ->append(['is_type'])
            ->limit($this->limitOffset, $this->limitLength)
            ->select()
            ->toArray();
        $goodsCategoryObj = GoodsCategory::where(['status'=>1])->order(['pid' => 'asc','weigh' => 'desc', 'id' => 'desc'])
            ->select();
        foreach ($lists as &$item) {
            $item['goods_category_ids'] = array_map("intval",$item['goods_category_ids']);
            $item['goods_category_ids_str'] = implode(' / ',$goodsCategoryObj->whereIn('id', $item['goods_category_ids'])->column('name'));
            $item['goods_image'] = $item['goods_image'] ?  FileService::getFileUrl($item['goods_image']):null;
            $item['goods_video'] = $item['goods_video'] ? FileService::getFileUrl($item['goods_video']):null;
        }
        return $lists;
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2024/07/07 18:37
     */
    public function count(): int
    {
        return Goods::where($this->searchWhere)->where($this->queryWhere())->count();
    }

}